(version 2)
(include "sci.sh")
(include "Verbs.sh")
(include "game.sh")
(include "110.shm")
(include "110.shp")
(exports
	0 rm110
)
(use "Main")
(use "DisposeLoad")
(use "Sound")
(use "Cycle")
(use "Game")
(use "View")
(use "Feature")
(use "Obj")
(use "Print")
(use "Polygon")

(script 110)

(define TOTALQUESTIONS    20) //How many questions you have messages set up for.
(define REQUIREDQUESTIONS  5) //How many must be answered.

(define QUESTIONLEFT     100) //Where and how the question is written.
(define QUESTIONTOP       32)
(define QUESTIONWIDTH    150)
(define QUESTIONFONT       4)
(define QUESTIONCOLOR      0)
(define ANSWERLEFT       100) //Where and how the first possible answer is written.
(define ANSWERTOP         60)
(define ANSWERWIDTH      170)
(define ANSWERSPACING     25) //How much space between each answer.
(define ANSWERFONT         4)
(define ANSWERCOLOR        0)
(define CORRECTCOLOR      35)
(define WRONGCOLOR        12)

(define BLACKSCREEN        0) //Picture # for the black screen. Questions use scriptNumber.
(define CORRECTSOUND     111)
(define WRONGSOUND       112)

(local
	questionsAsked
	wrongBefore
	correctAnswer
	answerGiven
	askedSoFar
	currentQuestion
	textBuffer[200]
)

/* END-USER PROCEDURES
 * -------------------
 * These need a bit of editing to be of any use.
 */

//If you leave this one as it is, you get an extra question that you can't answer :D
(procedure (EndThis)
	//(send gRoom:newRoom(120))
)

//Of course, you'd have to add a gLewdness to main.sc for this one.
(procedure (SetLewdness requestedLewdness)
	//= gLewdness requestedLewdness
)

// The rest of these are not quite as important but I documented it anyway.
// ---------------------------------------------------------------------------------


//We 
(instance AskedSoFar of List)

(procedure (PrepareQuestion)
	(var i)
	//Try to find a question we haven't asked yet first.
	//Yes, this might cause an infinite loop if the amount of questions is off.
	(while (1)
		= currentQuestion Random(1 TOTALQUESTIONS)
		(if (not (send askedSoFar:contains(currentQuestion)))
			break
		)
	)
	(send askedSoFar:add(currentQuestion))

	Message(msgGET scriptNumber 0 0 currentQuestion 1 @textBuffer)
	= correctAnswer (- (& textBuffer[0] $FF) $30)
	= textBuffer[0] (| (& textBuffer[0] $FF00) $20)

	Display(@textBuffer dsCOORD QUESTIONLEFT QUESTIONTOP dsCOLOR ANSWERCOLOR dsBACKGROUND -1 dsWIDTH QUESTIONWIDTH dsFONT QUESTIONFONT)
	
	(for (= i 0) (< i 4) (++i)
		Message(msgGET scriptNumber 0 0 currentQuestion (+ i 2) @textBuffer)
		Display(@textBuffer dsCOORD ANSWERLEFT (+ ANSWERTOP (* i ANSWERSPACING)) dsCOLOR ANSWERCOLOR dsBACKGROUND -1 dsWIDTH ANSWERWIDTH dsFONT ANSWERFONT)
	)
)

//This one's blatantly stolen from Larry 3, I'll admit it.
(procedure (ClickedInRect theEvent theLeft theTop theRight theBottom)
	(var x, y)
	= x (send theEvent: x)
	= y (send theEvent: y)
	return (if ((((> x theLeft) and (> y theTop)) and (< x theRight)) and (< y theBottom))
		1
	)(else
		0
	)
)

//Support function to keep the main part a little bit cleaner to read.
(procedure (TimedPrint theSequence theTime)
	(Print:
		font(gFont)
		ticks(theTime)
		mode(0)
		addText(1 0 0 theSequence 0 0 scriptNumber)
		init()
	)
)

(instance public rm110 of Rm
	(properties
		picture BLACKSCREEN
	)

	(method (init)
		(super:init())
		(send gOldMH:addToFront(self))
		(send gOldKH:addToFront(self))
		(send gGame:setCursor(996 1))
		(send gSq5IconBar: hide() disable())
		(send gUser:canInput(TRUE))
		= askedSoFar AskedSoFar
		(send askedSoFar: init())
		HideStatus()
		(self:setScript(rmScript))
	)

	(method (dispose param1)
		(send askedSoFar: dispose())
		(send gSq5IconBar: hide() enable())
		= gCursor 999
		(send gGame:setCursor(996 1))
		(send gOldKH:delete(self))
		(send gOldMH:delete(self))
		(super:dispose(rest param1))
	)
)

(instance rmScript of Script
	(properties)
	
	(method (changeState newState)
		(var requestedLewdness)

		(switch (= state newState)

			(case 0 //Asking for a rating.
				= gCursor 999
				(send gGame:setCursor(999 1))

				(= requestedLewdness (Print:
					font(gFont)
					width(240)
					mode(1)
					addTitle(1 0 0 1 scriptNumber)
					addText(1 0 0 2 0 0 scriptNumber)
					addButton(0 1 0 0 3 0 24 scriptNumber) //bail
					addButton(1 1 0 0 4 40 24 scriptNumber) //safe
					addButton(2 1 0 0 5 80 24 scriptNumber) //questionable
					addButton(3 1 0 0 6 180 24 scriptNumber) //explicit
					init()
				))

				//Requested lewdnesses go from 0-3, but only 1-3 are actual lewdnesses...
				(if (== requestedLewdness 0)
					TextPrint(1 0 0 7) //A little taunt on the way out, feel free to remove.
					= gQuitGame TRUE
					return
				)

				SetLewdness((- requestedLewdness 1)) //...so here we fix that little thing.

				(if (== requestedLewdness 1)
					TextPrint(1 0 0 8) //Safe's good.
					EndThis()
					return
				)

				= wrongBefore FALSE
				TextPrint(1 0 0 9) //Give the challenge
				DrawPic(scriptNumber dpANIMATION_BLACKOUT)
				PrepareQuestion()
				(send gSq5Music1: number(scriptNumber) loop(-1) play()) //drumroll please!
				= cycles 1
			)

			(case 1 //Waiting for a question to be answered.
				//doop de doo
			)

			(case 2 //Got an answer! Is it right!?

				//First, redraw the given answer in either green or red.
				Message(msgGET scriptNumber 0 0 currentQuestion (+ answerGiven 1) @textBuffer)
				Display(@textBuffer
					dsCOORD ANSWERLEFT (+ ANSWERTOP (* (- answerGiven 1) ANSWERSPACING))
					dsCOLOR (if (== answerGiven correctAnswer)
							CORRECTCOLOR
						)(else
							WRONGCOLOR
						)
					dsBACKGROUND -1
					dsWIDTH ANSWERWIDTH
					dsFONT ANSWERFONT)

				//Now, judge 'em.
				++questionsAsked
				(if (== answerGiven correctAnswer)
					(send gSq5Music2: number(CORRECTSOUND) play())
					(if (< questionsAsked REQUIREDQUESTIONS)
						TimedPrint(10 3) //Correct!
					)(else
						(send gSq5Music1: fade())
						TimedPrint(11 6) //Done!
						EndThis()
					)
				)(else
					(send gSq5Music2: number(WRONGSOUND) play())
					(if (== questionsAsked REQUIREDQUESTIONS)
						(send gSq5Music1: fade())
						TimedPrint(12 6) //You win anyway
						EndThis()
						return
					)
					(if (not wrongBefore)
						TimedPrint(13 4) //Fail one more time
						= wrongBefore TRUE
					)(else
						(send gSq5Music1: fade())
						TimedPrint(14 6) //You're a kid!
						= gQuitGame TRUE
					)
				)
				= seconds 1
			)

			(case 3 //Wait a bit and repeat
				DrawPic(scriptNumber dpOPEN_NO_TRANSITION) //Easiest way to remove the questions lol
				PrepareQuestion()
				= state 0 //This actually makes state 1, waiting for an answer, the next to occur.
				= cycles 1
			)

		)		
	)
	
	(method (handleEvent pEvent)
		(var i, left, top, right, bottom)
		(if (<> state 1)
			(super:handleEvent(pEvent))
			return
		)
		(switch ((send pEvent:type))
			(case evMOUSEBUTTON
				//Check each answer spot in turn.
				(for (= i 0) (< i 4) (++i)
					= left (- ANSWERLEFT 10)
					= top (+ ANSWERTOP (* i ANSWERSPACING))
					= right (+ (+ left ANSWERWIDTH) 20)
					= bottom (+ top ANSWERSPACING)
					(if (ClickedInRect(pEvent left top right bottom))
						= answerGiven (+ i 1)
						(self:cue())
						break
					)
				)
			)
			(case evKEYBOARD
				DebugPrint("evKEYBOARD, message %d modifier %d" (send pEvent:message) (send pEvent:modifiers))
				(switch ((send pEvent:message))
					(case KEY_a
						= answerGiven 1
						(self:cue())
					)
					(case KEY_b
						= answerGiven 2
						(self:cue())
					)
					(case KEY_c
						= answerGiven 3
						(self:cue())
					)
					(case KEY_d
						= answerGiven 4
						(self:cue())
					)
					(case KEY_A
						= answerGiven 1
						(self:cue())
					)
					(case KEY_B
						= answerGiven 2
						(self:cue())
					)
					(case KEY_C
						= answerGiven 3
						(self:cue())
					)
					(case KEY_D
						= answerGiven 4
						(self:cue())
					)
					(case $2D00
						(if (& (send pEvent:modifiers) 4)
							(send pEvent:claimed(1))
							(send gSq5Music1: fade())
							(send gSq5Music2: number(CORRECTSOUND) play())
							TimedPrint(15 6) //Cheater cheater pumpkin eater
							EndThis()
						)
					)
				)
			)
		)
	)
)
